var AP = {};

var setAP = function(aps, data, callback) {
    /*
    aps         Map of aps
    data        Map of data to insert
    callback    callback function
    */
    if (!data.has("mac") || data.mac=='') {
      console.error("no mac field");
      //console.error(data);
      return;
    }
    var ap;
    if (aps.has(data.mac)) { // bekannter client
      ap = aps.get(ap);
    } else { // neuer client
      ap = {
        mac : "00:00:00:00:00:00",
        ssid : "",
        hidden : false,
        name : "",
        pwr : 0,
        channel : 0,
        speed : 0,
        security : "",
        cipher : "",
        authentication : "",
        beacons : 0,
        iv : 0,
        ip : "",
        idLength : 0,
        key : "",
        packets : 0,
        last : "",
        first : "",
      }
    }
    for (let [k,v] of data.entries()) {
      if (k == "probed") {
        for (let k of v) {
          ap.probed.add(k);
        }
      } else if (k == "hidden") {
        if (v == "0") {
          ap[k] = false;
        } else {
          ap[k] = true;
        }
      } else if (k == "pwr" || k == "channel" || k == "speed" || k =="beacons" || k == "iv" || k == "idLength" || k == "packets") {
        ap[k] = parseInt(v);
      } else if (ap[k]!=null) {
        ap[k] = v;
      } else {
        console.error("no known field "+k);
      }
    }
    aps.set(ap.mac, ap);
}

AP.setAP = setAP;

module.exports = AP;
